

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.16. prefix_rk_search &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.17. query" href="query.html" />
    <link rel="prev" title="7.15.15. number_classify" href="number_classify.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/prefix_rk_search.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="query.html" title="7.15.17. query"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="number_classify.html" title="7.15.15. number_classify"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.16. </span><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="prefix-rk-search">
<h1><span class="section-number">7.15.16. </span><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code><a class="headerlink" href="#prefix-rk-search" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.16.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code> は <a class="reference internal" href="../operations/prefix_rk_search.html"><span class="doc">前方一致RK検索</span></a> を使ってレコードを選択します。</p>
<p>前方一致RK検索を使うには <a class="reference internal" href="../tables.html#table-pat-key"><span class="std std-ref">TABLE_PAT_KEY</span></a> テーブルを作る必要があります。</p>
<p>シーケンシャルスキャンでは <code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code> を使うことはできません。これはセレクターのみのプロシージャです。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.16.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code> には2つ引数があります。 <code class="docutils literal notranslate"><span class="pre">column</span></code> と <code class="docutils literal notranslate"><span class="pre">query</span></code> です。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>prefix_rk_search(column, query)
</pre></div>
</div>
<p>今のところ、 <code class="docutils literal notranslate"><span class="pre">column</span></code> は必ず <code class="docutils literal notranslate"><span class="pre">_key</span></code> にしなければいけません。</p>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> は文字列です。</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.16.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Readings TABLE_PAT_KEY ShortText --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Readings
[
{&quot;_key&quot;: &quot;ニホン&quot;},
{&quot;_key&quot;: &quot;ニッポン&quot;},
{&quot;_key&quot;: &quot;ローマジ&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>以下は簡単な <code class="docutils literal notranslate"><span class="pre">prefix_rk_search()</span></code> 関数の使い方です。この使い方では <code class="docutils literal notranslate"><span class="pre">ni</span></code> で <code class="docutils literal notranslate"><span class="pre">ニホン</span></code> と <code class="docutils literal notranslate"><span class="pre">ニッポン</span></code> を検索しています。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Readings --filter &#39;prefix_rk_search(_key, &quot;ni&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         2,
#         &quot;ニッポン&quot;
#       ],
#       [
#         1,
#         &quot;ニホン&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p><a class="reference internal" href="sub_filter.html"><span class="doc">sub_filter</span></a> と組み合わせることで <a class="reference internal" href="../suggest/completion.html"><span class="doc">補完</span></a> のような機能を実現することができます。</p>
<p>レコードが補完候補となるテーブルを作成します。各レコードには0個以上の読みがあります。読みは <code class="docutils literal notranslate"><span class="pre">Readings</span></code> テーブルに格納します。 <code class="docutils literal notranslate"><span class="pre">Readings</span></code> テーブルに <code class="docutils literal notranslate"><span class="pre">Items.readings</span></code> 用のインデックスカラムを定義することを忘れないでください。このインデックスカラムは <a class="reference internal" href="sub_filter.html"><span class="doc">sub_filter</span></a> で必要になります。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Items TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Items readings COLUMN_VECTOR Readings
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Readings items_index COLUMN_INDEX Items readings
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Items
[
{&quot;_key&quot;: &quot;日本&quot;,     &quot;readings&quot;: [&quot;ニホン&quot;, &quot;ニッポン&quot;]},
{&quot;_key&quot;: &quot;ローマ字&quot;, &quot;readings&quot;: [&quot;ローマジ&quot;]},
{&quot;_key&quot;: &quot;漢字&quot;,     &quot;readings&quot;: [&quot;カンジ&quot;]}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">niho</span></code> で <code class="docutils literal notranslate"><span class="pre">Items</span></code> テーブルの中にある <code class="docutils literal notranslate"><span class="pre">日本</span></code> レコードを見つけることができます。なぜなら、 <code class="docutils literal notranslate"><span class="pre">niho</span></code> で前方一致RK検索をすると <code class="docutils literal notranslate"><span class="pre">ニホン</span></code> という読みが見つかり、 <code class="docutils literal notranslate"><span class="pre">ニホン</span></code> という読みは <code class="docutils literal notranslate"><span class="pre">日本</span></code> レコードの読みの1つだからです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Items \
 --filter &#39;sub_filter(readings, &quot;prefix_rk_search(_key, \\&quot;niho\\&quot;)&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;readings&quot;,
#           &quot;Readings&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;日本&quot;,
#         [
#           &quot;ニホン&quot;,
#           &quot;ニッポン&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>読みがない補完候補をサポートするために <a class="reference internal" href="../grn_expr/script_syntax.html#script-syntax-prefix-search-operator"><span class="std std-ref">前方一致検索演算子</span></a> も組み合わせる必要があります。</p>
<p>読みがない補完候補を1つ追加します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Items
[
{&quot;_key&quot;: &quot;nihon&quot;, &quot;readings&quot;: []}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p>読みがない補完候補をサポートするために <a class="reference internal" href="../grn_expr/script_syntax.html#script-syntax-prefix-search-operator"><span class="std std-ref">前方一致検索演算子</span></a> を組み合わせます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Items \
 --filter &#39;sub_filter(readings, &quot;prefix_rk_search(_key, \\&quot;niho\\&quot;)&quot;) || _key @^ &quot;niho&quot;&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;readings&quot;,
#           &quot;Readings&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;日本&quot;,
#         [
#           &quot;ニホン&quot;,
#           &quot;ニッポン&quot;
#         ]
#       ],
#       [
#         4,
#         &quot;nihon&quot;,
#         []
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>多くの場合、補完時は大文字小文字を無視して検索したいものです。その場合は、 <code class="docutils literal notranslate"><span class="pre">--normalizer</span> <span class="pre">NormalizerAuto</span></code> と <code class="docutils literal notranslate"><span class="pre">label</span></code> カラムを使います。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create LooseItems TABLE_HASH_KEY ShortText --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create LooseItems label COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create LooseItems readings COLUMN_VECTOR Readings
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Readings loose_items_index COLUMN_INDEX LooseItems readings
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table LooseItems
[
{&quot;_key&quot;: &quot;日本&quot;,     &quot;label&quot;: &quot;日本&quot;,     &quot;readings&quot;: [&quot;ニホン&quot;, &quot;ニッポン&quot;]},
{&quot;_key&quot;: &quot;ローマ字&quot;, &quot;label&quot;: &quot;ローマ字&quot;, &quot;readings&quot;: [&quot;ローマジ&quot;]},
{&quot;_key&quot;: &quot;漢字&quot;,     &quot;label&quot;: &quot;漢字&quot;,     &quot;readings&quot;: [&quot;カンジ&quot;]},
{&quot;_key&quot;: &quot;Nihon&quot;,    &quot;label&quot;: &quot;日本&quot;,     &quot;readings&quot;: []}
]
# [[0, 1337566253.89858, 0.000355720520019531], 4]
</pre></div>
</div>
<p>表示するときは <code class="docutils literal notranslate"><span class="pre">LooseItems.label</span></code> を使います。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select LooseItems \
 --filter &#39;sub_filter(readings, &quot;prefix_rk_search(_key, \\&quot;nIhO\\&quot;)&quot;) || _key @^ &quot;nIhO&quot;&#39; \
 --output_columns &#39;_key,label&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;label&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         &quot;日本&quot;,
#         &quot;日本&quot;
#       ],
#       [
#         &quot;nihon&quot;,
#         &quot;日本&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.16.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>必須引数は二つあります。 <code class="docutils literal notranslate"><span class="pre">column</span></code> と <code class="docutils literal notranslate"><span class="pre">query</span></code> です。</p>
<div class="section" id="column">
<h3><span class="section-number">7.15.16.4.1. </span><code class="docutils literal notranslate"><span class="pre">column</span></code><a class="headerlink" href="#column" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>今のところ、常に <code class="docutils literal notranslate"><span class="pre">_key</span></code> を指定してください。</p>
</div>
<div class="section" id="query">
<h3><span class="section-number">7.15.16.4.2. </span><code class="docutils literal notranslate"><span class="pre">query</span></code><a class="headerlink" href="#query" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>クエリー文字列をローマ字、カタカナ、ひらがなのどれかで指定します。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.16.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code> 関数はマッチしたレコードを返します。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.16.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../operations/prefix_rk_search.html"><span class="doc">前方一致RK検索</span></a></p></li>
<li><p><a class="reference internal" href="sub_filter.html"><span class="doc">sub_filter</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.16. <code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.16.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.16.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.16.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.16.4. 引数</a><ul>
<li><a class="reference internal" href="#column">7.15.16.4.1. <code class="docutils literal notranslate"><span class="pre">column</span></code></a></li>
<li><a class="reference internal" href="#query">7.15.16.4.2. <code class="docutils literal notranslate"><span class="pre">query</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.16.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.15.16.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="number_classify.html"
                        title="前の章へ"><span class="section-number">7.15.15. </span><code class="docutils literal notranslate"><span class="pre">number_classify</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="query.html"
                        title="次の章へ"><span class="section-number">7.15.17. </span><code class="docutils literal notranslate"><span class="pre">query</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="query.html" title="7.15.17. query"
             >次へ</a> |</li>
        <li class="right" >
          <a href="number_classify.html" title="7.15.15. number_classify"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.16. </span><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>